###################################################
### chunk number 1: 
###################################################
#line 58 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
 options(continue="  ")
 options(width=65)


###################################################
### chunk number 2: 
###################################################
#line 145 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
library("dse")


###################################################
### chunk number 3:  eval=FALSE
###################################################
## #line 159 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
## data(package="dse")


###################################################
### chunk number 4: 
###################################################
#line 164 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
data(eg1.DSE.data, package="dse")  
data(egJofF.1dec93.data, package="dse")  


###################################################
### chunk number 5: 
###################################################
#line 262 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
fileName <- system.file("otherdata", "eg1.dat", package="dse")
eg1.DSE.data <- t(matrix(scan(fileName),5, 364))[, 2:5]


###################################################
### chunk number 6: 
###################################################
#line 268 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
eg1.DSE.data <- TSdata(input= eg1.DSE.data[,1,drop = F],
                      output= eg1.DSE.data[, 2:4, drop = F])


###################################################
### chunk number 7: 
###################################################
#line 275 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
eg1.DSE.data <-tframed(eg1.DSE.data, 
          list(start=c(1961,3), frequency=12)) 


###################################################
### chunk number 8: 
###################################################
#line 293 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
seriesNamesInput(eg1.DSE.data) <- "R90"
seriesNamesOutput(eg1.DSE.data) <- c("M1","GDPl2", "CPI") 


###################################################
### chunk number 9: 
###################################################
#line 309 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
model1 <- estVARXls(eg1.DSE.data)
model2 <- estSSMittnik(eg1.DSE.data, n=4) 
# or model2 <- estSSMittnik(eg1.DSE.data) prompts for state dimension


###################################################
### chunk number 10: 
###################################################
#line 325 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
summary(model1)
summary(model2)
model1
model2
stability(model1)
stability(model2)
informationTests(model1, model2)


###################################################
### chunk number 11: 
###################################################
#line 338 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
tfplot(model1)


###################################################
### chunk number 12: 
###################################################
#line 351 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
tfplot(model2)
tfplot(eg1.DSE.data)
checkResiduals(model1)
checkResiduals(model2) 


###################################################
### chunk number 13: 
###################################################
#line 411 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
AR <- array(c(1, .5, .3, 0, .2, .1, 0, .2, .05, 1, .5, .3),
            c(3,2,2)) 
MA <- array(c(1, .2, 0, .1, 0, 0, 1, .3), c(2,2,2)) 
arma <- ARMA(A=AR, B=MA, C=NULL) 
rm(AR, MA) # these can be removed from the environment as 
           #they are no longer needed 
arma 
stability(arma) 
data.arma.sim <- simulate(arma) 
arma <- l(arma, data.arma.sim) 
summary(arma) 
tfplot(data.arma.sim) 
tfplot(arma) 


###################################################
### chunk number 14: 
###################################################
#line 442 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
f <- array(c(.5, .3, .2, .4), c(2,2)) #Note: do not use capital
                                 #F (=FALSE) as a variable name
h <- array(c(1, 0, 0, 1), c(2,2))
k <- array(c(.5, .3, .2, .4), c(2,2))
ss <- SS(F=f, H=h, K=k) #F is argument name not variable name
print(ss)
stability(ss)
data.ss.sim <- simulate(ss)
ss <- l(ss, data.ss.sim)
summary(ss)
tfplot(ss) 


###################################################
### chunk number 15: 
###################################################
#line 467 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
ss.from.arma <- l(toSS(arma), data.arma.sim)
arma.from.ss <- l(toARMA(ss), data.ss.sim)
summary(ss.from.arma)
summary(arma)
summary(arma.from.ss)
summary(ss)
stability(arma)
stability(ss.from.arma) 


###################################################
### chunk number 16: 
###################################################
#line 496 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
tfplot(state(ss))


###################################################
### chunk number 17: 
###################################################
#line 516 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
ssc <- toSSChol(ss) 

ssc <- smoother(ssc)


###################################################
### chunk number 18: 
###################################################
#line 522 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
tfplot(state(ssc, filter=TRUE))

tfplot(state(ssc, smoother=TRUE))


###################################################
### chunk number 19: 
###################################################
#line 530 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
tfplot(state(ssc, smoother=TRUE), state(ssc, filter=TRUE))


###################################################
### chunk number 20: 
###################################################
#line 557 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
model.eg1.ls <- estVARXls(trimNA(eg1.DSE.data)) 


###################################################
### chunk number 21: 
###################################################
#line 570 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
subsample.data <- tfwindow(eg1.DSE.data, start=c(1972,1), 
   end=c(1992,12), warn=FALSE) 


###################################################
### chunk number 22: 
###################################################
#line 586 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
summary(model.eg1.ls)
print(model.eg1.ls)
tfplot(model.eg1.ls)
checkResiduals(model.eg1.ls) 


###################################################
### chunk number 23: 
###################################################
#line 595 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
model.eg1.ar <- estVARXar(trimNA(eg1.DSE.data))
model.eg1.ss <- estSSfromVARX(trimNA(eg1.DSE.data))
model.eg1.bft <- bft(trimNA(eg1.DSE.data))
model.eg1.mle <- estMaxLik(estVARXls(trimNA(eg1.DSE.data),
                           max.lag=1)) # see note below 


###################################################
### chunk number 24: 
###################################################
#line 605 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
tfplot(model.eg1.ls, model.eg1.ar)
tfplot(model.eg1.ls, model.eg1.ar, start=c(1990,1))


###################################################
### chunk number 25: 
###################################################
#line 643 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
eg4.DSE.data<- egJofF.1dec93.data
outputData(eg4.DSE.data) <- outputData(eg4.DSE.data, 
                                        series=c(1,2,6,7)) 


###################################################
### chunk number 26: 
###################################################
#line 651 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
model.eg4.bb <- estBlackBox(trimNA(eg4.DSE.data), max.lag=3) 


###################################################
### chunk number 27: 
###################################################
#line 665 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
informationTests(model.eg1.ar, model.eg1.ss) 


###################################################
### chunk number 28: 
###################################################
#line 692 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
eg4.DSE.model <- estVARXls(eg4.DSE.data) 


###################################################
### chunk number 29: 
###################################################
#line 699 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
new.data <- TSdata(
   input=ts(rbind(inputData(eg4.DSE.data), matrix(0.1,10,1)),
       start = start(eg4.DSE.data), 
       frequency = frequency(eg4.DSE.data)),
   output = ts(rbind(outputData(eg4.DSE.data), matrix(0.3,5,4)),
       start = start(eg4.DSE.data), 
       frequency = frequency(eg4.DSE.data))) 


###################################################
### chunk number 30: 
###################################################
#line 714 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
z <- l(TSmodel(eg4.DSE.model), trimNA(new.data)) 


###################################################
### chunk number 31: 
###################################################
#line 731 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
z <- forecast(TSmodel(eg4.DSE.model), new.data) 


###################################################
### chunk number 32: 
###################################################
#line 737 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
z <- forecast(TSmodel(eg4.DSE.model), trimNA(new.data),
              conditioning.inputs = inputData(new.data)) 


###################################################
### chunk number 33: 
###################################################
#line 746 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
tfplot(z, start=c(1990,6)) 


###################################################
### chunk number 34: 
###################################################
#line 755 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
z <- forecast(eg4.DSE.model, 
              conditioning.inputs.forecasts = matrix(0.5,6,1)) 


###################################################
### chunk number 35: 
###################################################
#line 765 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
summary(z)

print(z)

tfplot(z)

tfplot(z, start=c(1990,1)) 


###################################################
### chunk number 36: 
###################################################
#line 777 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
forecasts(z)[[1]]


###################################################
### chunk number 37: 
###################################################
#line 784 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
tfwindow(forecasts(z)[[1]], start=c(1994,1), warn=FALSE) 


###################################################
### chunk number 38: 
###################################################
#line 804 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
z <- l(TSmodel(eg4.DSE.model), new.data)


###################################################
### chunk number 39: 
###################################################
#line 809 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
tfplot(z)


###################################################
### chunk number 40: 
###################################################
#line 827 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
z <- featherForecasts(TSmodel(eg4.DSE.model), new.data)
tfplot(z)


###################################################
### chunk number 41: 
###################################################
#line 835 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
z <- featherForecasts(TSmodel(eg4.DSE.model), new.data, 
 from.periods = c(20, 50, 60, 70, 80), horizon=150)


###################################################
### chunk number 42: 
###################################################
#line 841 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
tfplot(z)


###################################################
### chunk number 43: 
###################################################
#line 848 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
z <- horizonForecasts(TSmodel(eg4.DSE.model), new.data, 
                      horizons = c(1,3,6))


###################################################
### chunk number 44: 
###################################################
#line 854 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
tfplot(z)


###################################################
### chunk number 45: 
###################################################
#line 887 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
fc <- forecastCov(TSmodel(eg4.DSE.model), data = eg4.DSE.data)
tfplot(fc)
tfplot(forecastCov(TSmodel(eg4.DSE.model), data = eg4.DSE.data, 
                   horizons = 1:4)) 


###################################################
### chunk number 46: 
###################################################
#line 897 "d:/Rcompile/CRANpkg/local/2.12/dse/inst/doc/Guide.Stex"
fc <- forecastCov(TSmodel(eg4.DSE.model), data = eg4.DSE.data, 
                  zero = T, trend =T )
tfplot(fc)


